note
	description: "Summary description for {ABSTRACT_STATE_MACHINE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	ABSTRACT_STATE_MACHINE
inherit
	THREAD


feature {NONE}

	make (l: MUTEX)
		do
			lock := l
			state := []
			create guards.make
			create actions.make
		end



feature -- queries
	lock: MUTEX

	state: TUPLE

	guards: LINKED_LIST [FUNCTION [ANY, TUPLE, BOOLEAN]]

	actions: LINKED_LIST [PROCEDURE [ANY, TUPLE]]

	guard (i: INTEGER_32): BOOLEAN
		do
			Result := guards [i].item ([])
		end

	count : INTEGER
		do
			Result := guards.count
		end


feature -- command

	print_output
		deferred
		end

	act (i: INTEGER_32)
		do
			actions [i].call ([])
		end

	execute
		local
			rn: RANDOM
			i,j,k: INTEGER
			done1, done2: BOOLEAN
		do
			from
				create rn.make
			until
				done1
			loop
				done2 := false
				rn.forth
				i := rn.item
				k := (rn.item\\ count) + 1

				lock.lock

				if guard(k) then
					act(k)
				end
				lock.unlock
				current.sleep(5000000000) -- 2 seconds
				print_output

			end

		end

invariant
	guards.count = actions.count

end -- class ABSTRACT_STATE_MACHINE

