note
	description: "Summary description for {STATE_MACHINE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	STATE_MACHINE


inherit
	ABSTRACT_STATE_MACHINE
		redefine
			make, state
		end

inherit {NONE}

	STATE_CONSTANTS

create
	make


feature {NONE}-- init


	make (l: MUTEX)
			-- state is  motor_guard, motor_state door_guard, door_state,
		do
			Precursor (l)
			set_initial_state
			-- enter event guards and actions
			guards.extend (agent motor_start_guard)
			actions.extend (agent motor_start_action)
			guards.extend (agent motor_on_guard)
			actions.extend (agent motor_on_action)
			guards.extend (agent motor_stop_guard)
			actions.extend (agent motor_stop_action)
			guards.extend (agent motor_off_guard)
			actions.extend (agent motor_off_action)
			guards.extend (agent door_opening_guard)
			actions.extend (agent door_opening_action)
			guards.extend (agent door_open_guard)
			actions.extend (agent door_open_action)
			guards.extend (agent door_closing_guard)
			actions.extend (agent door_closing_action)
			guards.extend (agent door_close_guard)
			actions.extend (agent door_close_action)
			launch
		end

	set_initial_state
			-- motor off and door closed
		do
			state := [false, off, false, closed]
		end

feature -- state and inputs

	set_motor_guard(b: BOOLEAN)
		do
			state.b1 := b
		end

	set_door_guard(b: BOOLEAN)
		do
			state.b2 := b
		end

	state: TUPLE[b1: BOOLEAN; x1: STRING; b2: BOOLEAN; x2: STRING]
		-- [motor_guard, motor_state, door_guard, door_state]

	print_output
		do
			print("x1 = " + state.x1.out + ",%T" + "x2 = " + state.x2.out + "%N")
		end

feature -- motor guards and events

	motor_start_guard: BOOLEAN
		do
			Result := state.b1 = true and state.x1 ~ off
		end

	motor_start_action
		do
			state.x1 := starting
		end

	motor_on_guard: BOOLEAN
		do
			Result := state.x1 = starting
		end

	motor_on_action
		do
			state.x1 := on
		end

	motor_stop_guard: BOOLEAN
		do
			Result := state.b1 = false and state.x1 ~ on
		end

	motor_stop_action
		do
			state.x1 := stopping
		end

	motor_off_guard: BOOLEAN
		do
			Result := state.x1 ~ stopping
		end

	motor_off_action
		do
			state.x1 := off
		end

feature -- door guards and events

	door_opening_guard: BOOLEAN
		do
			Result := state.b2 = true and state.x2 ~ closed
		end

	door_opening_action
		do
			state.x2 := opening
		end

	door_open_guard: BOOLEAN
		do
			Result := state.x2 = opening
		end

	door_open_action
		do
			state.x2 := open
		end

	door_closing_guard: BOOLEAN
		do
			Result := state.b2 = false and state.x2 ~ open
		end

	door_closing_action
		do
			state.x2 := closing
		end

	door_close_guard: BOOLEAN
		do
			Result := state.x2 ~ closing
		end

	door_close_action
		do
			state.x2 := closed
		end

invariant

	state.x2 ~ closed or state.x1 ~ off
	is_motor_state (state.x1) and is_door_state (state.x2)

end -- class STATE_MACHINE

